<?php

namespace NF\Discord\Admin\Controller;

use XF\Admin\Controller\AbstractController;

use NF\Discord\Api;

class Group extends AbstractController
{
	public function actionUser()
	{
		$viewParams = [
			'userGroups' => $this->getUserGroupRepo()->findUserGroupsForList()->fetch(),
		];
		return $this->view('XF:UserGroup\Listing', 'user_group_list', $viewParams);
	}

	/**
	 * @param string $id
	 * @param array|string|null $with
	 * @param null|string $phraseKey
	 *
	 * @return \XF\Entity\UserGroup
	 */
	protected function assertUserGroupExists($id, $with = null, $phraseKey = null)
	{
		return $this->assertRecordExists('XF:UserGroup', $id, $with, $phraseKey);
	}

	/**
	 * @return \XF\Repository\UserGroup
	 */
	protected function getUserGroupRepo()
	{
		return $this->repository('XF:UserGroup');
	}
}