<?php

namespace NF\Discord\ConnectedAccount\ProviderData;

use XF\ConnectedAccount\ProviderData\AbstractProviderData;

class Discord extends AbstractProviderData
{
	public function getDefaultEndpoint()
	{
		return 'users/@me';
	}

	public function getProviderKey()
	{
		return $this->requestFromEndpoint('id');
	}

	public function getUsername()
	{
		return $this->requestFromEndpoint('username');
	}

	public function getEmail()
	{
		return $this->requestFromEndpoint('email');
	}

	public function getDiscriminator()
	{
		return $this->requestFromEndpoint('discriminator');
	}

	public function getProfileLink()
	{
		return $this->requestFromEndpoint('profile');
	}

	public function getAvatarUrl()
	{
		$id = $this->getProviderKey();
		$avatarId = $this->requestFromEndpoint('avatar');

		if (!$avatarId)
		{
			$id = $this->getDiscriminator() % 5;
			return "https://cdn.discordapp.com/embed/avatars/$id.png";
		}

		return "https://cdn.discordapp.com/avatars/$id/$avatarId.png";
	}
}