<?php

namespace NF\Discord\SV\ReportCentreEssentials\Admin\Controller;

use NF\Discord\Api;
use XF\Mvc\FormAction;

/**
 * Extends \SV\ReportCentreEssentials\Admin\Controller\ReportQueue
 */
class ReportQueue extends XFCP_ReportQueue
{
	/**
	 * @param \SV\ReportCentreEssentials\Entity\ReportQueue $reportQueue
	 *
	 * @return \XF\Mvc\Reply\View
	 * @throws \XF\PrintableException
	 */
	protected function reportQueueAddEdit(\SV\ReportCentreEssentials\Entity\ReportQueue $reportQueue)
	{
		$reply = parent::reportQueueAddEdit($reportQueue);

		if ($reply instanceof \XF\Mvc\Reply\View)
		{
			$api = Api::factory();
			$reply->setParam('discordChannels', $api->getChannels(Api::CHANNEL_TYPE_TEXT, true));
		}

		return $reply;
	}

	/**
	 * @param \SV\ReportCentreEssentials\Entity\ReportQueue $reportQueue
	 *
	 * @return \XF\Mvc\FormAction
	 */
	protected function reportQueueSaveProcess(\SV\ReportCentreEssentials\Entity\ReportQueue $reportQueue)
	{
		$form = parent::reportQueueSaveProcess($reportQueue);

		$input = $this->filter([
			'nf_discord_channel_id' => 'uint',
			'nf_discord_new_reports' => 'bool',
			'nf_discord_reopened_reports' => 'bool',
			'nf_discord_old_report_first_threshold' => 'uint',
			'nf_discord_old_report_repeat_threshold' => 'uint',
			'nf_discord_open_count' => 'uint',
			'nf_discord_open_threshold' => 'uint',
		]);
		$form->setupEntityInput($reportQueue, $input);

		return $form;
	}
}