<?php

namespace NF\Discord\SV\ReportCentreEssentials\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

/**
 * Extends \SV\ReportCentreEssentials\Entity\ReportQueue
 *
 * @property string nf_discord_channel_id
 *
 * @property bool nf_discord_new_reports
 * @property bool nf_discord_reopened_reports
 *
 * @property int nf_discord_old_report_first_threshold
 * @property int nf_discord_old_report_repeat_threshold
 * @property bool nf_discord_old_report_repeating
 * @property int nf_discord_old_report_timestamp
 *
 * @property int nf_discord_open_count
 * @property int nf_discord_open_threshold
 * @property int nf_discord_open_timestamp
 */
class ReportQueue extends XFCP_ReportQueue
{
	/**
	 * @param Structure $structure
	 *
	 * @return Structure
	 */
	public static function getStructure(Structure $structure)
	{
		$structure = parent::getStructure($structure);

		$structure->columns['nf_discord_channel_id'] = ['type' => self::STR, 'max' => 64, 'default' => 0];

		$structure->columns['nf_discord_new_reports'] = ['type' => self::BOOL, 'default' => false];
		$structure->columns['nf_discord_reopened_reports'] = ['type' => self::BOOL, 'default' => false];

		$structure->columns['nf_discord_old_report_first_threshold'] = ['type' => self::UINT, 'default' => 0];
		$structure->columns['nf_discord_old_report_repeat_threshold'] = ['type' => self::UINT, 'default' => 0];
		$structure->columns['nf_discord_old_report_repeating'] = ['type' => self::BOOL, 'default' => false];
		$structure->columns['nf_discord_old_report_timestamp'] = ['type' => self::UINT, 'default' => 0];

		$structure->columns['nf_discord_open_count'] = ['type' => self::UINT, 'default' => 0];
		$structure->columns['nf_discord_open_threshold'] = ['type' => self::UINT, 'default' => 0];
		$structure->columns['nf_discord_open_timestamp'] = ['type' => self::UINT, 'default' => 0];

		return $structure;
	}
}