<?php

namespace NF\Discord\XF\Admin\Controller;

use NF\Discord\Api;
use XF\Mvc\FormAction;
use XF\Mvc\ParameterBag;

/**
 * Extends \XF\Admin\Controller\Forum
 */
class Forum extends XFCP_Forum
{
	protected function nodeAddEdit(\XF\Entity\Node $node)
	{
		$reply = parent::nodeAddEdit($node);

		if ($reply instanceof \XF\Mvc\Reply\View)
		{
			$api = Api::factory();
			$reply->setParam('discordChannels', $api->getChannels(Api::CHANNEL_TYPE_TEXT, true));
		}

		return $reply;
	}

	protected function saveTypeData(FormAction $form, \XF\Entity\Node $node, \XF\Entity\AbstractNode $data)
	{
		parent::saveTypeData($form, $node, $data);

		$form->setup(function () use ($data)
		{
			$data->nf_discord_channel_id = $this->filter('nf_discord_channel_id', 'uint');
			$data->nf_discord_include_replies = $this->filter('nf_discord_include_replies', 'bool');
		});
	}
}