<?php

namespace NF\Discord\XF\Entity;

use NF\Discord\Api;

class UserBan extends XFCP_UserBan
{
	protected function _postSave()
	{
		parent::_postSave();

		if ($this->User->is_banned)
		{
			$linkedDiscord = $this->User->ConnectedAccounts['nfDiscord'];

			if ($linkedDiscord)
			{
				\XF::runLater(function () use ($linkedDiscord)
				{
					$api = Api::factory(false);
					if ($api)
					{
						$api->banGuildMember($linkedDiscord->provider_key);
					}
				});
			}
		}
	}

	protected function _postDelete()
	{
		parent::_postDelete();

		$linkedDiscord = $this->User->ConnectedAccounts['nfDiscord'];
		if ($linkedDiscord)
		{
			\XF::runLater(function () use ($linkedDiscord)
			{
				$api = Api::factory(false);
				if ($api)
				{
					$api->unbanGuildMember($linkedDiscord->provider_key);
				}
			});
		}
	}
}