<?php

namespace NF\Discord\XF\Entity;

use XF\Mvc\Entity\Structure;

/**
 * Extends \XF\Entity\UserGroup
 *
 * @property int[] nfd_server_group_ids
 */
class UserGroup extends XFCP_UserGroup
{
	protected function _postSave()
	{
		parent::_postSave();
		$userGroupId = $this->user_group_id;
		\XF::runOnce('nfd-group-sync', function () use ($userGroupId)
		{
			\XF::app()->jobManager()->enqueueUnique('nfd-group-sync', 'NF\Discord:GroupSync', ['user_group_id' => $userGroupId]);
		});
	}

	public function verifynfdServerGroupIds(&$value)
	{
		$ids = is_array($value) ? $value : explode(',', $value);
		$class = \XF::extendClass('NF\Discord\Api');
		/** @var \NF\Discord\Api $api */
		$api = new $class();

		if (count($ids) > 0)
		{
			foreach ($ids as &$id)
			{
				$role = $api->getRole($id);

				if (!array_key_exists('name', $role))
				{
					unset($id);
				}
			}
			$value = $ids;
			return true;
		}
		return true;
	}

	public static function getStructure(Structure $structure)
	{
		$structure = parent::getStructure($structure);

		$structure->columns['nfd_server_group_ids'] = ['type' => self::LIST_COMMA, 'default' => []];

		return $structure;
	}
}
