<?php

namespace NF\Discord\XF\Repository;

/*
 * Extends \XF\Repository\ForumWatch
 */

class ForumWatch extends XFCP_ForumWatch
{
	public function setDiscordWatchState(\XF\Entity\Forum $forum, \XF\Entity\User $user, $notifyType = null, $sendDiscord = null)
	{
		if (!$forum->node_id || !$user->user_id)
		{
			throw new \InvalidArgumentException('Invalid forum or user');
		}

		$watch = $this->em->find('XF:ForumWatch', [
			'node_id' => $forum->node_id,
			'user_id' => $user->user_id,
		]);

		switch ($notifyType)
		{
			case 'message':
			case 'thread':
			case '':
			case null:
				if (!$watch)
				{
					$watch = $this->em->create('XF:ForumWatch');
					$watch->node_id = $forum->node_id;
					$watch->user_id = $user->user_id;
				}
				if ($notifyType !== null)
				{
					$watch->notify_on = $notifyType;
				}
				if ($sendDiscord !== null)
				{
					$watch->send_discord = $sendDiscord;
				}

				$watch->save();
				break;

			case 'delete':
				if ($watch)
				{
					$watch->delete();
				}
				break;

			default:
				throw new \InvalidArgumentException("Unknown notify type '$notifyType'");
		}
	}
}
