<?php

namespace NF\Discord\XFRM\Admin\Controller;

use NF\Discord\Api;
use XF\Mvc\FormAction;

/**
 * Extends \XFRM\Admin\Controller\Category
 */
class Category extends XFCP_Category
{
	public function categoryAddEdit(\XFRM\Entity\Category $category)
	{
		$reply = parent::categoryAddEdit($category);

		if ($reply instanceof \XF\Mvc\Reply\View)
		{
			$api = Api::factory();
			$reply->setParam('discordChannels', $api->getChannels(Api::CHANNEL_TYPE_TEXT, true));
		}

		return $reply;
	}

	protected function categorySaveProcess(\XFRM\Entity\Category $category)
	{
		$form = parent::categorySaveProcess($category);

		$form->setup(function () use ($category)
		{
			$category->nf_discord_channel_id = $this->filter('nf_discord_channel_id', 'uint');
		});

		return $form;
	}
}